<?php

declare(strict_types=1);

namespace App\Service;

use App\Repository\TblHistorialEvaluacionesRepository;

final class TblHistorialEvaluacionesService
{
    private TblHistorialEvaluacionesRepository $TblHistorialEvaluacionesRepository;

    public function __construct(TblHistorialEvaluacionesRepository $TblHistorialEvaluacionesRepository)
    {
        $this->TblHistorialEvaluacionesRepository = $TblHistorialEvaluacionesRepository;
    }

    public function checkAndGet(int $TblHistorialEvaluacionesId): object
    {
        return $this->TblHistorialEvaluacionesRepository->checkAndGet($TblHistorialEvaluacionesId);
    }

    public function getAll(): array
    {
        return $this->TblHistorialEvaluacionesRepository->getAll();
    }

    public function getOne(int $TblHistorialEvaluacionesId): object
    {
        return $this->checkAndGet($TblHistorialEvaluacionesId);
    }

    public function create(array $input): object
    {
        $TblHistorialEvaluaciones = json_decode((string) json_encode($input), false);

        return $this->TblHistorialEvaluacionesRepository->create($TblHistorialEvaluaciones);
    }

    public function update(array $input, int $TblHistorialEvaluacionesId): object
    {
        $TblHistorialEvaluaciones = $this->checkAndGet($TblHistorialEvaluacionesId);
        $data = json_decode((string) json_encode($input), false);

        return $this->TblHistorialEvaluacionesRepository->update($TblHistorialEvaluaciones, $data);
    }

    public function delete(int $TblHistorialEvaluacionesId): void
    {
        $this->checkAndGet($TblHistorialEvaluacionesId);
        $this->TblHistorialEvaluacionesRepository->delete($TblHistorialEvaluacionesId);
    }
}
